{
	Skanti TRP8255 control program (CU8000 control unit)
	This program was developed for a CU8000 control unit marked
        TRP 8255 S R GB1. May work or not with other units.

        Copyright (C) 2012 G. Perotti, I1EPJ, i1epj@aricasale.it

        This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/.
}

unit skanti;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus, ExtCtrls, Buttons, ComCtrls, serial, types, LCLType, mouse, user, UAbout, UGNU, UMAN;

type

  { TTRP }

  TTRP = class(TForm)
          BBFODN: TBitBtn;
          BBFOUP: TBitBtn;
          BTUNEDN: TBitBtn;
          BTUNEUP: TBitBtn;
          BSENSUP: TBitBtn;
          BDIMDN: TBitBtn;
          BDIMUP: TBitBtn;
          BSENSDN: TBitBtn;
          BVOLUP: TBitBtn;
          BVOLDN: TBitBtn;
          BTXEQRX: TButton;
          MENALL: TMenuItem;
          MRESET: TMenuItem;
          MRELPRIO: TMenuItem;
          MenuItem3: TMenuItem;
          MOTFUN: TMenuItem;
          MGNULIC: TMenuItem;
          MABOUT: TMenuItem;
          MMAN: TMenuItem;
          MHelp: TMenuItem;
          MRCONF: TMenuItem;
          MLSTATE: TMenuItem;
          MSSTATE: TMenuItem;
          MenuItem5: TMenuItem;
          MRTU: TMenuItem;
          MRCU: TMenuItem;
          MRBFO: TMenuItem;
          MTRANS: TMenuItem;
          MStatus: TMenuItem;
          MSG: TLabel;
          MenuItem1: TMenuItem;
          MCustom: TMenuItem;
          MESG: TTimer;
          Clock: TTimer;
          OpenDialog1: TOpenDialog;
          SaveDialog1: TSaveDialog;
          SM: TTimer;
          STSIG: TStaticText;
          STPWR: TStaticText;
          WMeter: TProgressBar;
          SMETER: TProgressBar;
          TStatus: TTimer;
          STEP10H: TShape;
          Step100H: TShape;
          STEP1K: TShape;
          PLOW: TShape;
          SRPWR: TShape;
          TX: TTimer;
    BUSB: TButton;
    BRATE: TButton;
    BWIDE: TButton;
    BINTER: TButton;
    BNAR: TButton;
    BVNAR: TButton;
    BSPKR: TButton;
    BLSB: TButton;
    BRFAMP: TButton;
    BRFATT: TButton;
    BSQL: TButton;
    AGCON: TButton;
    AGCFAST: TButton;
    AGCSLOW: TButton;
    AGCOFF: TButton;
    TUNE: TButton;
    BLOW: TButton;
    BMED: TButton;
    BAM: TButton;
    BFULL: TButton;
    BRX: TButton;
    BRCL: TButton;
    BTX: TButton;
    B7: TButton;
    B8: TButton;
    B9: TButton;
    B4: TButton;
    B5: TButton;
    B6: TButton;
    BTELEX: TButton;
    B1: TButton;
    B2: TButton;
    B3: TButton;
    ENTER: TButton;
    B0: TButton;
    BR3E: TButton;
    BONOFF: TButton;
    BTXONOFF: TButton;
    BSTO: TButton;
    BSCAN: TButton;
    BSETT: TButton;
    BDUP: TButton;
    BTRANS: TButton;
    BCW: TButton;
    BMCW: TButton;
    B500: TButton;
    B2182: TButton;
    RXfreq: TLabel;
    TXfreq: TLabel;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    M300b: TMenuItem;
    M2400B: TMenuItem;
    MExit: TMenuItem;
    MOptions: TMenuItem;
    MPort: TMenuItem;
    MSpeed: TMenuItem;
    Mttys0: TMenuItem;
    Mttys1: TMenuItem;
    procedure AGCFASTClick(Sender: TObject);
    procedure AGCOFFClick(Sender: TObject);
    procedure AGCONClick(Sender: TObject);
    procedure AGCSLOWClick(Sender: TObject);
    procedure B2182Click(Sender: TObject);
    procedure B4Click(Sender: TObject);
    procedure B7Click(Sender: TObject);
    procedure B8Click(Sender: TObject);
    procedure B9Click(Sender: TObject);
    procedure BBFOUPClick(Sender: TObject);
    procedure BDUPClick(Sender: TObject);
    procedure BSCANClick(Sender: TObject);
    procedure BSETTClick(Sender: TObject);
    procedure BTUNEUPClick(Sender: TObject);
    procedure BFULLClick(Sender: TObject);
    procedure BBFODNClick(Sender: TObject);
    procedure BTUNEDNClick(Sender: TObject);
    procedure BSENSUPClick(Sender: TObject);
    procedure BDIMDNClick(Sender: TObject);
    procedure BDIMUPClick(Sender: TObject);
    procedure BSENSDNClick(Sender: TObject);
    procedure B500Click(Sender: TObject);
    procedure BVOLUPClick(Sender: TObject);
    procedure BVOLDNClick(Sender: TObject);
    procedure BLOWClick(Sender: TObject);
    procedure BMEDClick(Sender: TObject);
    procedure BRCLClick(Sender: TObject);
    procedure BRFATTClick(Sender: TObject);
    procedure BSQLClick(Sender: TObject);
    procedure BTXEQRXClick(Sender: TObject);
    procedure BRATEClick(Sender: TObject);
    procedure BRXClick(Sender: TObject);
    procedure BTXClick(Sender: TObject);
    procedure B5Click(Sender: TObject);
    procedure B6Click(Sender: TObject);
    procedure B2Click(Sender: TObject);
    procedure B3Click(Sender: TObject);
    procedure B0Click(Sender: TObject);
    procedure BTXONOFFClick(Sender: TObject);
    procedure BWIDEClick(Sender: TObject);
    procedure BTRANSClick(Sender: TObject);
    procedure BINTERClick(Sender: TObject);
    procedure BNARClick(Sender: TObject);
    procedure BVNARClick(Sender: TObject);
    procedure BSPKRClick(Sender: TObject);
    procedure BRFAMPClick(Sender: TObject);
    procedure BSTOClick(Sender: TObject);
    procedure ClockTimer(Sender: TObject);
    procedure ENTERClick(Sender: TObject);
    procedure BMCWClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure MABOUTClick(Sender: TObject);
    procedure MENALLClick(Sender: TObject);
    procedure MGNULICClick(Sender: TObject);
    procedure MLSTATEClick(Sender: TObject);
    procedure MMANClick(Sender: TObject);
    procedure MRCONFClick(Sender: TObject);
    procedure MRELPRIOClick(Sender: TObject);
    procedure MRESETClick(Sender: TObject);
    procedure MRTUClick(Sender: TObject);
    procedure MExitClick(Sender: TObject);
    procedure MRBFOClick(Sender: TObject);
    procedure MRCUClick(Sender: TObject);
    procedure MSSTATEClick(Sender: TObject);
    procedure MStatusClick(Sender: TObject);
    procedure MTRANSClick(Sender: TObject);
    procedure RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    procedure STEP100HMouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    procedure STEP10HMouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    procedure STEP1KMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MESGTimer(Sender: TObject);
    procedure SMTimer(Sender: TObject);
    procedure TStatusTimer(Sender: TObject);
    procedure TUNEClick(Sender: TObject);
    procedure B1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
            WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure BONOFFClick(Sender: TObject);
    procedure BCWClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure M2400BClick(Sender: TObject);
    procedure M300BClick(Sender: TObject);
    procedure MCustomClick(Sender: TObject);
    procedure Mttys0Click(Sender: TObject);
    procedure Mttys1Click(Sender: TObject);
    procedure BTELEXClick(Sender: TObject);
    procedure BLSBClick(Sender: TObject);
    procedure BAMClick(Sender: TObject);
    procedure BR3EClick(Sender: TObject);
    procedure TXfreqMouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    procedure TXTimer(Sender: TObject);
    procedure BUSBClick(Sender: TObject);
    procedure Numkey(keyp: string);
    procedure DispRXf;
    procedure DispTXf;
    procedure UpdatePanel;
    function SendCommand(cmd, par: string): boolean;
    function GetReply(ReplyLen: integer): string;
    function OpenRemote: boolean;
    function CloseRemote: boolean;
    function SetRXFreq: boolean;
    function SetTXFreq: boolean;
    procedure SaveLastState;
    procedure LoadLastState;
    procedure RestoreState;
    procedure SaveConfig;
    procedure ReadConfig;
    procedure Message(ms: string);
    procedure DispBFOFreq(s: string);
    procedure DisableAllControls;
    procedure EnableAllControls;
  private
    { private declarations }
  public
    { public declarations }
  end; 

Const { Skanti command values }
  RemoteEnable:   String = #1#2;    // SOH STX
  RemoteDisable:  String = #16;     // DLE
  RTX_Reset:      String = '!';     // Reset
  TX_Cmd:         String = '"';     // " Double quote mark (has 3 sec timeout)
  RX_Cmd:         String = '#';     // #

  TX_Prefix:      String = ';';     // ; + ASCII value + cr
  RX_Prefix:      String = ':';     // : + ASCII value + cr
//	NOTE!  The value represents the frequency in multiples of 100Hz

  RecallChannel:  String = '<';     // + ASCII value + cr
  Tune_Dn:        String = '=';     // Fine tune down. See 'w'
  Tune_Up:        String = '>';     // Fine tune up. See 'w'
  BFO_Tune_Up:    String = '@';     // BCW Beat tone Up 100Hz
  BFO_Tune_Dn:    String = 'A';     // BCW Beat tone Down 100Hz
  Filt_Wide:      String = 'B';     // Where enabled
  Filt_Inter:     String = 'C';     // Where enabled
  Filt_Narrow:    String = 'D';     // Where enabled
  Filt_VNarrow:   String = 'E';     // Where enabled
  Speaker_Toggle: String = 'F';     // Toggle On/Off  (See Mute/UnMute)
  PreAmp_Toggle:  String = 'G';     // Toggle On/Off
  Atten_Toggle:   String = 'H';     // Toggle On/Off
  Squelch_Toggle: String = 'I';     // Toggle On/Off
  Agc_On:         String = 'J';
  Agc_Fast:       String = 'K';
  Agc_Slow:       String = 'L';
  Agc_Off:        String = 'M';
  Sensitivity_Dn: String = 'N';     // Increment RF Gain Down (AGC must be OFF)
  Sensitivity_Up: String = 'O';     // Increment RF Gain Up (AGC must be OFF)
  AF_GainDec:     String = 'P';     // 'P';     // Increment Volume DAC Down.
  AF_GainInc:     String = 'Q';     // 'Q';     // Increment Volume DAC Up.
  TX_Tune:        String = 'R';     // Invoke TX tuning.
  TX_LowPwr:      String = 'S';
  TX_MediumPwr:   String = 'U';
  TX_HighPwr:     String = 'W';
  Mode_USB:       String = 'X';
  Mode_LSB:       String = 'Y';
  Mode_AM:        String = 'Z';
  Mode_Telex:     String = '[';
  Mode_R3E:       String = '\';
  Mode_CW:        String = ']';
  Mode_MCW:       String = '^';

  StoreChannel:   String = 'd';     // d + ASCII value + cr
  Scan:		  String = 'e';
  Set_Time:       String = 'f';     // 'f1234'#13 will set the time to 12:34
  Duplex:         String = 'g';

  Dimmer_Dn:      String = 'h';     // Display intensity down
  Dimmer_Up:      String = 'i';     // Display intensity up.
  TX_OnOff:       String = 'j';     // Toggle TX Enable (On/Off)
  UnMute:         String = 'k';
  Mute:           String = 'l';     // lower case L
  PreAmp_On:      String = 'm';     // RF Pre-Amp Enable
  PreAmp_Off:     String = 'n';     // RF Pre-Amp Disable
  Attenuator_On:  String = 'o';     // Antenna Attenuator Enable
  Attenuator_Off: String = 'p';     // Antenna Attenuatro Diasable

  TX_Enable:      String = 'u';     // Enable (turn on) Transmitter.
  TX_Disable:     String = 'v';     // Disable (turn off) Transmitter.

  TuneStep1k:     String = 'w2'#13; // RX Fine Tune Step 1kHz
  TuneStep100:    String = 'w1'#13; // RX Fine Tune Step 100Hz
  TuneStep10:     String = 'w0'#13; // RX Fine Tune Step 10Hz

  AF_GainSet:     String = 'y';     // 'y..'#13
                                    //   .. = 00 = maximum (!! LOUD !!)
                                    //   .. = 99 = minimum

  Dimmer_Set:     string = 'z';     // 'z.'#13
                                    //   . = 0 = display off
                                    //   . = 5 = display maximum

  EQTXRX:         string = ':;'#13; // Copy RX frequency to TX

  F500k:          string = '`';     // Go to 500 kHz
  F2182k:         string = '_';     // Go to 2182 kHz

  Get_Status:     string = '*';     // Read status (S-meter, etc.)
  Read_Config:	  string = '(';     // Read configuration string

  ACK:            string = #$06;
  ETX:            string = #$03;
  EOT:            string = #$04;
  NAK:            string = #$15;
  CAN:            string = #$18;
  CR:             string = #$0D;

  // Valid range of meter reading
  MetersRange = ['`'..'t'];

  // Valid range of status messages
  StatusRange = ['u'..'z'];

  // Filenames
  StateFileName:  string = 'LastState.dat';
  ConfigFileName: string = 'Config.dat';

  // Messages
  CANTTUNE:       string = 'TX can''t tune to that frequency';
  COMMANDFAILED:  string = 'Command failed';
  // Mode values
  M_USB = 1;
  M_LSB = 2;
  M_AM  = 3;
  M_R3E = 4;
  M_CW  = 5;
  M_MCW = 6;
  M_TLX = 7;
  M_500K = 8;
  M_2182K = 9;

  // Filter values
  FILTER_Default = 0;
  FILTER_WIDE = 1;
  FILTER_INTERMEDIATE = 2;
  FILTER_NARROW = 3;
  FILTER_VERYNARROW = 4;

  // AGC values
  AVC_OFF = 0;
  AVC_ON = 1;
  AVC_FAST = 2;
  AVC_SLOW = 3;

  // TX power
  LOW_POWER = 1;
  MEDIUM_POWER = 2;
  FULL_POWER = 3;

  // frequency coverage
  MINRXF = 10000;
  MAXRXF = 29999990;
  MINTXF = 1605000;
  MAXTXF = 29999990;

  // 1 ms time value (1/86400000)
  const time1ms: double = 11.5740740740740740741e-9;

Type
  TRTXState = record
    Freq_rx: longint;
    Freq_tx: longint;
    Freq_step: integer;
    BFO_freq: integer;
    Mode: integer;
    Filter: integer;
    AGC: integer;
    Speaker_Enabled: boolean;
    RFamp_Enabled: boolean;
    RFAtt_Enabled: boolean;
    Squelch_Enabled: boolean;
    Sensitivity: integer;
    Volume: integer;
    TX_power: integer;
    TX_Enabled: boolean;
    PTT_State: boolean;
  end;


var
  TRP: TTRP;
  RTXState: TRTXState;
  SerPort: TSerialHandle = 0;
  SerPortName: string = '/dev/ttyS0';
  SerPortSpeed: integer = 2400;
  s,t: integer;
  status: string;
  STimer1, STimer2: integer;
  RXFBuf, TXFBuf, OldRXFreq, OldTXFreq: string;
  SetRXf: boolean = FALSE;
  SetTXf: boolean = FALSE;
  StoChan: boolean = FALSE;
  RclChan: boolean = FALSE;
  SetClock: boolean = FALSE;
  Enable_status: boolean = FALSE;
  In_Wheel: boolean = FALSE;
  flash: boolean = TRUE;
  tmp: longint;
  HomeDir,StateDir: string;
  timeout: TTime;

implementation

{$R *.lfm}

{ TTRP }

//
// Auxiliary procedures & functions
//

// Open communications
function TTRP.OpenRemote: boolean;

begin
     	Result := SendCommand(RemoteEnable, '');
        if Result then begin
	        Result := Result and SendCommand(CR, '');
        	Result := Result and SendCommand(CR, '');
	        Result := Result and SendCommand(CR, '');
        end;
end;

// Close communications
function TTRP.CloseRemote: boolean;
begin
        CloseRemote := SendCommand(RemoteDisable, '');
end;

// Send a command to CU8000
function TTRP.SendCommand(cmd, par: string): boolean;

var resp: char = chr(0);
    tmp: string;
    retry: integer = 10;
    i,nc: integer;
    ok: boolean = TRUE;

begin
        Enable_Status := FALSE;

        tmp := cmd+par;

        if SerPort <> 0  then begin
                for i := 1 to length(tmp) do begin
                        repeat
	                	nc := SerWrite(SerPort, tmp[i], 1);
                                if nc <> 1 then begin
                                        Message('SerWrite returned ' + IntToStr(nc));
                                end;

        	        	timeout := time + 1000*time1ms;
                	        repeat
                			nc := SerRead(SerPort, resp, 1);
	                	until (nc > 0) or (time > timeout);

                                if nc <> 1 then
                                         Message('SerRead returned ' + IntToStr(nc));

        	                if (resp <> NAK) and (resp <> ACK) then begin
                	        	Message('SendCommand received '+ resp);
                        	        ok := FALSE;
	                        end;

        	                if resp = NAK then begin
					Message('NAK received, retriyng...');
					ok := FALSE;
                                	retry := retry - 1;
                                        sleep(100);
	                        end;
        	                if (time > timeout) then begin
                	                Message('Timeout expired (CMD)');
                        	        ok := FALSE;
	                        end;
                        until ok or (time > timeout) or (retry = 0);
              	end;
	end;
        if MStatus.Checked then Enable_status := TRUE;
        SendCommand := ok;
end;

//
// Get reply to command
//

function TTRP.GetReply(ReplyLen: integer): string;

var stmp: string;
    buf:  char = chr(0);
    resp: char = chr(0);
    i,nc: integer;

begin
    stmp := '';
    buf := ACK[1];
    for i := 1 to ReplyLen do begin
            SerWrite(SerPort, buf, 1);
	    timeout := time + 1000*time1ms;
            repeat
                    nc := SerRead(SerPort, resp, 1);
            until ((nc > 0) and (resp < '`')) or (time > timeout);
            stmp := stmp + resp;
            GetReply := stmp;
    end;
    SerWrite(SerPort, buf, 1);
end;

// Set RX frequency
function TTRP.SetRXFreq: boolean;

var  f: longint;
    sf: string;

    begin
	f := RTXstate.Freq_rx div 100;
      	str(f, sf);
	while Length(sf) < 6 do sf := '0' + sf;
	sf := sf + CR;
	SetRXFreq := SendCommand(RX_Prefix, sf);
end;

// Set TX frequency
function TTRP.SetTXFreq: boolean;

var  f: longint;
    sf: string;

    begin
	f := RTXstate.Freq_tx div 100;
      	str(f, sf);
	while Length(sf) < 6 do sf := '0' + sf;
	sf := sf + CR;
	SetTXFreq := SendCommand(TX_Prefix, sf);
end;

// Display a message in MSG label
procedure TTRP.Message(ms: string);
begin
    MESG.Interval := 10000;
    MESG.Enabled := TRUE;
    MSG.Caption := ms;
    Application.ProcessMessages;
end;

// Display RX frequency
procedure TTRP.DispRXf;

var tmp: real;
    s: string;

begin
       	tmp := RTXState.Freq_rx / 1000.0;
        if RTXState.Freq_step = 10 then begin
                str(tmp:8:2,s);
        end else begin
                str(tmp:7:1,s);
                s := s + ' ';
        end;
     	RXFreq.Caption := s;
        Application.ProcessMessages;
end;

// Display TX frequency (100 Hz steps only)
procedure TTRP.DispTXf;

var tmp: real;
    s: string;

begin
      	tmp := RTXState.Freq_tx / 1000.0;
        str(tmp:7:1,s);
        s := s + ' ';
     	TXFreq.Caption := s;
        Application.ProcessMessages;
end;

// Display BFO frequency
procedure TTRP.DispBFOFreq(s: string);
begin
	Message('BFO = '+copy(s,1,2)+'.'+s[3]+' kHz');
end;

// Mumeric keys handler
procedure TTRP.NumKey(keyp: string);

var f: double;
    len: integer;

begin
        if SetRXf then begin
                if RxFBuf <> '' then f := StrToFloat(RXFBuf) else f := 0;
        	if f < 30000 then RXFBuf := RXFBuf + keyp;
                RXfreq.Caption := FloatToStrF(StrToFloat(RXFBuf)/10,ffFixed,5,1)+' ';
        end;

        if SetTXf then begin
                if TxFBuf <> '' then f := StrToFloat(TXFBuf) else f := 0;
        	if f < 30000 then TXFBuf := TXFBuf + keyp;
                TXfreq.Caption := FloatToStrF(StrToFloat(TXFBuf)/10,ffFixed,5,1)+' ';
        end;

        if StoChan or RclChan then begin
               	len := Length(RXFBuf);
                case len of
                        0: if (keyp[1] in ['0'..'7']) then RXFBuf := RXFBuf + keyp;
                        1: begin
                        	if (RXFBuf[1] in ['0'..'6']) or
                                   ((RXfbuf[1] = '7') and (keyp[1] in ['0'..'5'])) then
                                           RXfBuf := RXFBuf + keyp;
                        end;
                end;
                RXfreq.Caption := RXFBuf;
        end;

        if SetClock then begin
               	len := Length(RXFBuf);
                case len of
                        0: if (keyp[1] in ['0'..'2']) then RXFBuf := RXFBuf + keyp;
                        1: if (RXFbuf[1] in ['0'..'1']) or
                              ((RXFBuf[1] = '2') and(keyp[1] in ['0'..'3'])) then
                                      RXFBuf := RXFBuf + keyp;
                        2: if (keyp[1] in ['0'..'5']) then RXFBuf := RXFBuf + keyp;
                        3: RXFBuf := RXFBuf + keyp;
                end;
                RXfreq.Caption := RXFBuf;
        end;

end;

// Save config to disk
procedure TTRP.SaveConfig;

var ConfigFile: Text;

begin
     AssignFile(ConfigFile, HomeDir+ConfigFileName);
     {$I-}
     Rewrite(ConfigFile);
     {$I+}
     if IOResult = 0 then begin
	     WriteLn(ConfigFile, SerPortName);
             Writeln(ConfigFile, SerPortSpeed);

             if MStatus.Checked then
                     WriteLn(ConfigFile,'TRUE')
             else
                     WriteLn(ConfigFile, 'FALSE');

             if MTrans.Checked then
                     WriteLn(ConfigFile,'TRUE')
             else
                     WriteLn(ConfigFile, 'FALSE');

             if MENALL.Checked then
                     WriteLn(ConfigFile,'TRUE')
             else
                     WriteLn(ConfigFile, 'FALSE');
             CloseFile(ConfigFile);
     end;
end;

// Read config from disk
procedure TTRP.ReadConfig;

var ConfigFile: Text;
    s: string;

begin
     AssignFile(ConfigFile, HomeDir+ConfigFileName);
     {$I-}
     Reset(ConfigFile);
     {$I+}
     if IOResult = 0 then begin
	     ReadLn(ConfigFile, SerPortName);
             ReadLn(ConfigFile, SerPortSpeed);
             ReadLn(ConfigFile,s);
             MStatus.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             MTrans.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             MENALL.Checked := (s = 'TRUE');
	     CloseFile(ConfigFile);
     end else begin
             // default values
             SerPortName := '/dev/ttyS0';
             SerPortSpeed := 300;
             MStatus.Checked := FALSE;
             MTrans.Checked := FALSE;
     end;
     if SerPortName = '/dev/ttyS0' then begin
	     Mttys0.Checked := TRUE;
             Mttys1.Checked := FALSE;
             MCustom.Checked := FALSE;
     end else begin
     	if SerPortName = '/dev/ttyS1' then begin
             Mttys0.Checked := FALSE;
             Mttys1.Checked := TRUE;
             MCustom.Checked := FALSE;
     	end else begin
             Mttys0.Checked := FALSE;
             Mttys1.Checked := FALSE;
             MCustom.Checked := TRUE;
     	end;
     end;

     if SerPortSpeed = 300 then begin
          M300B.Checked := TRUE;
          M2400B.Checked := FALSE;
     end else begin
             M300B.Checked := FALSE;
             M2400B.Checked := TRUE;
     end;
end;

// Save last state to disk
procedure TTRP.SaveLastState;

var StateFile: FILE of TRTXState;

begin
     AssignFile(StateFile, HomeDir+StateFileName);
     {$I-}
     Rewrite(StateFile);
     {$I+}
     if IOResult = 0 then begin
	     Write(StateFile, RTXState);
	     CloseFile(StateFile);
     end;
end;

// Read last autosaved state from disk or set default state
procedure TTRP.LoadLastState;

var StateFile: FILE of TRTXState;

    begin
	AssignFile(StateFile, HomeDir+StateFileName);
        {$I-}
        Reset(StateFile);
        {$I+}
        if IOResult = 0 then begin
        	Read(StateFile, RTXState);
                CloseFile(StateFile);
        end else begin
	        // Default values if no last state file found
                with RTXstate do begin
        		Freq_rx := 14000000;
	        	Freq_tx := 14000000;
        		Freq_step := 1000;
                	BFO_freq := 800;
                	Mode := M_USB;
                	Filter := FILTER_DEFAULT;
                	AGC := AVC_SLOW;
                	Speaker_Enabled := TRUE;
                	RFamp_Enabled := FALSE;
                	RFAtt_Enabled := FALSE;
                	Squelch_Enabled := FALSE;
                	Sensitivity := 0;
                	Volume := 80;
                	TX_power := FULL_POWER;
                	TX_Enabled := TRUE;
                	PTT_state := FALSE;
	        	Mode := M_USB;
                end;
         end;

end;


// Disable all controls except ON/OFF and some menus
procedure TTRP.DisableAllControls;

var i: integer;

begin
	for i := 0 to ComponentCount - 1 do begin
		if Components[i] is TControl then begin
			TControl(Components[i]).Enabled := FALSE;
		end;
        end;
        MLState.Enabled := FALSE;
        MSState.Enabled := FALSE;
        MOtFun.Enabled := FALSE;
        MStatus.Enabled := FALSE;
        MTrans.Enabled := FALSE;
        BONOFF.Enabled := TRUE;
end;

// Enable all controls
procedure TTRP.EnableAllCOntrols;

var i: integer;

begin
    for i := 0 to ComponentCount - 1 do begin
	if Components[i] is TControl then begin
  		TControl(Components[i]).Enabled := TRUE;
        end;
       	if Components[i] is TMenuItem then begin
         		TMenuItem(Components[i]).Enabled := TRUE;
	end;
    end;
end;

// Update indicators state
procedure TTRP.UpdatePanel;

begin
	// frequency step
    	case RTXState.Freq_step of
                10: begin
                        STEP10H.Brush.Color := ClLime;
                        STEP100H.Brush.Color := ClGreen;
                        STEP1K.Brush.Color := ClGreen;
                end;
                100: begin
                        STEP10H.Brush.Color := ClGreen;
                        STEP100H.Brush.Color := ClLime;
                        STEP1K.Brush.Color := ClGreen;
                end;
                1000: begin
                        STEP10H.Brush.Color := ClGreen;
                        STEP100H.Brush.Color := ClGreen;
                        STEP1K.Brush.Color := ClLime;
                end;
    	end;

        // Meters
        if Mstatus.Checked then begin
                Enable_Status := TRUE;
               	Tstatus.Enabled := TRUE;
                SMETER.Visible := TRUE;
       	        WMETER.Visible := TRUE;
                STSIG.Visible := TRUE;
                STPWR.Visible := TRUE;
        end else begin;
       	     	Tstatus.Enabled := FALSE;
                Enable_Status := FALSE;
              	SMETER.Visible := FALSE;
     	        WMETER.Visible := FALSE;
                STSIG.Visible := FALSE;
                STPWR.Visible := FALSE;
        end;

        // filter
        case RTXState.Filter of
                FILTER_DEFAULT: begin
                        BWIDE.Color := clDefault;
                        BINTER.Color := clDefault;
                        BNAR.Color := clDefault;
                        BVNAR.Color := clDefault;
                end;
                FILTER_WIDE: begin
                        BWIDE.Color := clLime;
                        BINTER.Color := clDefault;
                        BNAR.Color := clDefault;
                        BVNAR.Color := clDefault;
                end;
                FILTER_INTERMEDIATE: begin
                        BWIDE.Color := clDefault;
                        BINTER.Color := clLime;
                        BNAR.Color := clDefault;
                        BVNAR.Color := clDefault;
                end;
                FILTER_NARROW: begin
                        BWIDE.Color := clDefault;
                        BINTER.Color := clDefault;
                        BNAR.Color := clLime;
                        BVNAR.Color := clDefault;
                end;
                FILTER_VERYNARROW: begin
                        BWIDE.Color := clDefault;
                        BINTER.Color := clDefault;
                        BNAR.Color := clDefault;
                        BVNAR.Color := clLime;
                end;
        end;

        // SPEAKER
        if RTXState.Speaker_Enabled then
        	BSPKR.Color := clLime
        else
        	BSPKR.Color := clDefault;

        // RF AMPLIFIER
        if RTXState.RFamp_Enabled then
        	BRFAMP.Color := clLime
        else
        	BRFAMP.Color := clDefault;

        // RF ATTENUATOR
        if RTXState.RFatt_Enabled then
        	BRFATT.Color := clLime
        else
        	BRFATT.Color := clDefault;

        // SQUELCH
        if RTXState.Squelch_Enabled then
        	BSQL.Color := clLime
        else
        	BSQL.Color := clDefault;

        // AGC
        case RTXState.AGC of
                AVC_ON: begin
                     	AGCON.Color := clLime;
                     	AGCSLOW.Color := clLime;
                     	AGCFAST.Color := clDefault;
                     	AGCOFF.Color := clDefault;
                     	if not MENALL.Checked then begin
				BSENSDN.Enabled := FALSE;
                     		BSENSUP.Enabled := FALSE;
                     	end;
                end;

                AVC_FAST: begin
                        AGCON.Color := clLime;
                        AGCSLOW.Color := clDefault;
                        AGCFAST.Color := clLime;
                        AGCOFF.Color := clDefault;
	                if not MENALL.Checked then begin
                                BSENSDN.Enabled := FALSE;
                        	BSENSUP.Enabled := FALSE;
                     	end;
                end;

                AVC_SLOW: begin
                        AGCON.Color := clLime;
                        AGCSLOW.Color := clLime;
                        AGCFAST.Color := clDefault;
                        AGCOFF.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BSENSDN.Enabled := FALSE;
        	                BSENSUP.Enabled := FALSE;
                        end;
                end;

                AVC_OFF: begin
                        AGCON.Color := clDefault;
                        AGCSLOW.Color := clDefault;
                        AGCFAST.Color := clDefault;
                        AGCOFF.Color := clLime;
                        BSENSDN.Enabled := TRUE;
       	                BSENSUP.Enabled := TRUE;
                end;
        end;

        // MODE
        case RTXState.Mode of
      		M_LSB: begin
	       		BLSB.Color := clLime;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
			if not MENALL.Checked then begin
                        	BBFODN.Enabled := FALSE;
                        	BBFOUP.Enabled := FALSE;
                        end;
                        AGCSLOW.Enabled := TRUE;
                        AGCOFF.Enabled := TRUE;
                       end;
		M_USB: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clLime;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
			end;
                        AGCSLOW.Enabled := TRUE;
                        AGCOFF.Enabled := TRUE;
		       end;
		M_AM: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clLime;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
                	        AGCSLOW.Enabled := FALSE;
                        end;
                        AGCOFF.Enabled := TRUE;
                      end;
		M_TLX: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clLime;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
                	        AGCSLOW.Enabled := FALSE;
                        	AGCOFF.Enabled := FALSE;
                        end;
                end;
		M_CW: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clLime;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                        BBFODN.Enabled := TRUE;
                        BBFOUP.Enabled := TRUE;
                        AGCSLOW.Enabled := TRUE;
                        AGCOFF.Enabled := TRUE;
                      end;
		M_MCW: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clLime;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                      	if not MENALL.Checked then begin
                       		BBFODN.Enabled := FALSE;
                        	BBFOUP.Enabled := FALSE;
                        end;
                        AGCSLOW.Enabled := TRUE;
                        AGCOFF.Enabled := TRUE;
  		end;
		M_R3E: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clLime;
                        B500.Color := clDefault;
                        B2182.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
                        end;
                        AGCSLOW.Enabled := TRUE;
                        AGCOFF.Enabled := TRUE;
      		end;
		M_500K: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clLime;
                        B2182.Color := clDefault;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
                        end;
                end;
		M_2182K: begin
	       		BLSB.Color := clDefault;
			BUSB.Color := clDefault;
			BAM.Color := clDefault;
			BTELEX.Color := clDefault;
			BCW.Color := clDefault;
			BMCW.Color := clDefault;
			BR3E.Color := clDefault;
                        B500.Color := clDefault;
                        B2182.Color := clLime;
                        if not MENALL.Checked then begin
	                        BBFODN.Enabled := FALSE;
        	                BBFOUP.Enabled := FALSE;
                        end;
                end;
        end;

        //Power
        case RTXState.TX_power of
                LOW_POWER: begin
                        BLOW.Color := clLime;
                        BMED.Color := clDefault;
                        BFULL.Color := clDefault;
                end;
                MEDIUM_POWER: begin
                     BLOW.Color := clDefault;
                     BMED.Color := clLime;
                     BFULL.Color := clDefault;
                end;
                FULL_POWER: begin
                     BLOW.Color := clDefault;
                     BMED.Color := clDefault;
                     BFULL.Color := clLime;
                end;
        end;


        // TX ON/OFF & TX frequency display (clock when TX disabled)
        if RTXState.TX_Enabled then begin
                Clock.Enabled := FALSE;
                BTXONOFF.Color := clLime;
        end else begin
                Clock.Enabled := TRUE;
                BTXONOFF.Color := clRED;
        end;

        // RX/TX
        if RTXState.PTT_State then begin
        	BTRANS.Color := ClRed;
        end else begin
	        BTRANS.Color := clLime;
        end;
end;

// Restore state in RTXState
procedure TTRP.RestoreState;

var cmd: string;

begin
        //Show frequencies
        DispRXf;
        DispTXf;

        // Set RX frequency
	if not SetRXfreq then
                Message(COMMANDFAILED);
        sleep(250);

        // Set TX frequency
	if not SetTXfreq then
                Message(COMMANDFAILED);
        sleep(250);

        // Set frequency step
        case RTXState.Freq_step of
                  10: cmd := TuneStep10;
                 100: cmd := TuneStep100;
                1000: cmd := TuneStep1k;
        end;
        if not SendCommand(cmd, '') then
                Message(COMMANDFAILED);
	sleep(50);

        // Set mode
        case RTXState.Mode of
                M_USB: cmd := Mode_USB;
                M_LSB: cmd := Mode_LSB;
                M_AM:  cmd := Mode_AM;
                M_R3E: cmd := Mode_R3E;
                M_CW:  cmd := Mode_CW;
                M_MCW: cmd := Mode_MCW;
                M_TLX: cmd := Mode_Telex;
        end;
        if not SendCommand(cmd, '') then
                Message(COMMANDFAILED);
        sleep(50);

        // Set filter
        case RTXState.Filter of
                FILTER_WIDE: cmd := Filt_Wide;
                FILTER_INTERMEDIATE: cmd := Filt_Inter;
                FILTER_NARROW:  cmd := Filt_Narrow;
                FILTER_VERYNARROW: cmd := Filt_VNarrow;
        end;
        if not SendCommand(cmd, '') then
                Message(COMMANDFAILED);
	sleep(50);

        // Set AGC
        case RTXState.AGC of
                AVC_ON: cmd := AGC_On;
                AVC_OFF: cmd := AGC_Off;
                AVC_FAST: cmd := AGC_Fast;
                AVC_SLOW: cmd := AGC_Slow;
        end;
        if not SendCommand(cmd, '') then
                Message(COMMANDFAILED);
	sleep(50);

        // Set volume
        if not SendCommand(AF_GainSet,IntToStr(RTXState.Volume)+CR) then
                Message(COMMANDFAILED);
	sleep(50);

        //Set speaker
        if RTXState.Speaker_Enabled then begin
                if not SendCommand(UnMute, '') then Message(COMMANDFAILED)
        end else begin
                if not SendCommand(Mute, '') then Message(COMMANDFAILED);
        end;
	sleep(50);

        // Set TX ON/OFF
        if RTXState.TX_Enabled then begin
                if not SendCommand(TX_Enable, '') then Message(COMMANDFAILED);
        end else begin
                if not SendCommand(TX_Disable, '') then Message(COMMANDFAILED);
        end;

        // Set power
	case RTXState.TX_power of
                LOW_POWER: cmd := TX_LowPwr;
                MEDIUM_POWER: cmd := TX_MediumPwr;
                FULL_POWER: cmd := TX_HighPwr;
        end;
        if not SendCommand(cmd, '') then Message(COMMANDFAILED);
 	sleep(50);

        // Status polling
        if MStatus.Checked then begin
        	TStatus.Enabled := TRUE;
                SMETER.Visible := TRUE;
                WMETER.Visible := TRUE;
        end else begin
                TStatus.Enabled := FALSE;
                SMETER.Visible := FALSE;
                WMETER.Visible := FALSE;
        end;
end;

//
// Object init & functions
//

// Various initializations
procedure TTRP.FormCreate(Sender: TObject);

var i: integer;

begin

        // Disable all controls except ON/OFF key
    	for i := 0 to ComponentCount - 1 do begin
		if Components[i] is TControl then begin
	  		TControl(Components[i]).Enabled := FALSE;
                end;
	end;
        MLState.Enabled := FALSE;
        MSState.Enabled := FALSE;
        MOtFun.Enabled := FALSE;
        MStatus.Enabled := FALSE;
        MTrans.Enabled := FALSE;
        BONOFF.Enabled := TRUE;

        // Button captions requiring two lines
        AGCON.Caption := 'AGC'+LineEnding+'ON';
        AGCFAST.Caption := 'AGC'+LineEnding+'FAST';
        AGCSLOW.Caption := ' AGC'+LineEnding+'SLOW';
        AGCOFF.Caption := 'AGC'+LineEnding+'OFF';
        BONOFF.Caption := 'SUPPLY'+LineEnding+'ON/OFF';
        BSETT.Caption := ' SET'+LineEnding+'TIME';
        BDUP.Caption := ' DU'+LineEnding+'PLEX';
        BRATE.Caption := 'TUNE'+LineEnding+'RATE';
        BTXONOFF.Caption := '   TX'+LineEnding+'ON/OFF';
        BVNAR.Caption := 'VERY'+LineEnding+'NARR';

        // Read config
        ReadConfig;
end;

// Allows to enter frequency using the keyboard
procedure TTRP.FormKeyPress(Sender: TObject; var Key: char);
begin
//	Message('Key pressed: '+Key);
        if SetRXf or SetTXf or RCLChan or STOChan or SetClock then begin
        	if key in ['0'..'9'] then NumKey(Key);
                if Key = chr(13) then EnterClick(Sender);
        end;
        Key := chr(0);
end;

// Allows to use mouse wheel for tuning
procedure TTRP.FormMouseWheel(Sender: TObject; Shift: TShiftState;
        WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);

begin
	if In_Wheel then exit;
     	In_Wheel := TRUE;
     	If WheelDelta > 0 then begin
     		if SendCommand(Tune_Up, '') then begin
	     		if RTXState.Freq_rx+RTXState.Freq_step <= MAXRXF then begin
        	        	RTXState.Freq_rx := RTXState.Freq_rx + RTXState.Freq_step;
				sleep(150);
        	                DispRXf;
                        end else Message(COMMANDFAILED);
             	end;
     	end;
     	If WheelDelta < 0 then begin
        	if SendCommand(Tune_Dn, '') then begin
             		if RTXState.Freq_rx-RTXState.Freq_step >= MINRXF then begin
               			RTXState.Freq_rx := RTXState.Freq_rx - RTXState.Freq_step;
	                        sleep(150);
        	                DispRXf;
                        end else Message(COMMANDFAILED);
             	end;
     	end;

        if MTRANS.Checked then begin
                if RTXState.freq_rx >= MINTXF then begin
       			sleep(150);
       			RTXState.Freq_tx := RTXState.Freq_rx;
                	if not SetTXFreq then Message(COMMANDFAILED);
       	        	DispTXf;
        		sleep(150);
                end else Message(CANTTUNE);
       end;
     	Handled := TRUE;
     	In_Wheel := FALSE;
end;

//
// Menu handling
//

// "File" menu handling

// "Load state"
procedure TTRP.MLSTATEClick(Sender: TObject);

var StateFile: FILE of TRTXState;

begin
        OpenDialog1.InitialDir := StateDir;
        If OpenDialog1.Execute then begin
        	AssignFile(StateFile,OpenDialog1.Filename);
                {$I-}
                Reset(StateFile);
                {$I+}
                if IOResult = 0 then begin
                	Read(StateFile,RTXState);
                        CloseFile(StateFile);
                end;
                RestoreState;
                UpdatePanel;
        end;
end;

// "Save state"
procedure TTRP.MSSTATEClick(Sender: TObject);

var StateFile: file of TRTXState;
    SMode: string;

begin
    	case RTXState.Mode of
                M_USB: SMode := 'USB';
                M_LSB: SMode := 'LSB';
                M_AM:  Smode := 'AM';
                M_TLX: SMode := 'TELEX';
                M_R3E: SMode := 'R3E';
                M_CW:  SMode := 'CW';
                M_MCW: SMode := 'MCW';
        end;
        SaveDialog1.InitialDir := StateDir;
        SaveDialog1.FileName := Trim(RXFreq.Caption)+'-'+SMode+'.dat';
        If SaveDialog1.Execute then begin
        	AssignFile(StateFile,SaveDialog1.Filename);
                {$I-}
                Rewrite(StateFile);
                {$I+}
                if IOResult = 0 then begin
                	Write(StateFile,RTXState);
                        CloseFile(StateFile);
                end;
        end;
end;


// "Exit"
procedure TTRP.MExitClick(Sender: TObject);
begin
        if MStatus.Checked then begin
                TStatus.Enabled := FALSE;
                Enable_sTATUS := FALSE;
        end;
        sleep(100);
        CloseRemote;
	SerFlush(SerPort);
	SerClose(SerPort);
    	SaveConfig;
    	SaveLastState;
        Halt;
end;

//
// "Other functions" menu handling
//

// "Read configuration"
procedure TTRP.MRCONFClick(Sender: TObject);

var nc:  integer;
    buf: char =chr(0);
    resp: string = '';
begin
        if SendCommand(Read_Config, '') then begin
	        sleep(100);
        	repeat
	        	nc := SerRead(SerPort, buf, 1);
	        until (nc > 0) and (buf = '*');
        	repeat
	      		SerWrite(SerPort, ACK[1], 1);
	                repeat
        			nc := SerRead(SerPort, buf, 1);
		        until (nc > 0);
        	        if buf <> '>' then resp := resp + buf;
	        until buf = '>';
	      	SerWrite(SerPort, ACK[1], 1);
	        Message('Configuration: '+ resp);
	end else Message(COMMANDFAILED);
end;

// "Read BFO frequency"
procedure TTRP.MRBFOClick(Sender: TObject);

var s: string;

begin
        if SendCommand('244', CR+CR) then begin
	        s := GetReply(3);
	        DispBFOFreq(s);
	        sleep(250);
	        if not SendCommand(CR, '') then Message(COMMANDFAILED);
	        Sleep(1000);
	        RestoreState;
	        UpdatePanel;
        end else Message(COMMANDFAILED);
end;

// "Read CU version"
procedure TTRP.MRCUClick(Sender: TObject);

begin
        if SendCommand('246', CR) then begin
	        Message('CU ' + Copy(GetReply(13),2,11));
	        sleep(250);
        	if not SendCommand(CR, '') then Message(COMMANDFAILED);
	        Sleep(1000);
	        RestoreState;
	        UpdatePanel;
        end else Message(COMMANDFAILED);
end;

// "Read TU version"
procedure TTRP.MRTUClick(Sender: TObject);
begin
	if SendCommand('247', CR) then begin
	        Message('TU ' + Copy(GetReply(13),2,11));
	        sleep(250);
	        if not SendCommand(CR, '') then Message(COMMANDFAILED);
	        sleep(1000);
	        RestoreState;
	        UpdatePanel;
        end else Message(COMMANDFAILED);
end;

// "Release remote priority"
procedure TTRP.MRELPRIOClick(Sender: TObject);
begin
	if SendCommand(EOT,'') then
                Message('Remote priority released')
        else
                Message(COMMANDFAILED);
end;

// "Reset RTX"
procedure TTRP.MRESETClick(Sender: TObject);
begin
        TStatus.Enabled := FALSE;
	if SendCommand(RTX_RESET, '') then begin
		Message('Reset done');
        end else Message(COMMANDFAILED);
        SerFlush(SerPort);
        SerClose(SerPort);
        SerPort := 0;
        DisableAllControls;
end;

//
// "Options" menu handling
//

// "RS232 port"

// "ttyS0"
procedure TTRP.Mttys0Click(Sender: TObject);
begin
     	Mttys0.Checked := TRUE;
     	Mttys1.Checked := FALSE;
        MCustom.Checked :=FALSE;
        SerPortName := '/dev/ttyS0';
        SaveConfig;
end;

// "ttyS1"
procedure TTRP.Mttys1Click(Sender: TObject);
begin
        Mttys0.Checked := FALSE;
        Mttys1.Checked := TRUE;
        MCustom.Checked :=FALSE;
        SerPortName := '/dev/ttyS1';
        SaveConfig;
end;

// "Custom..."
procedure TTRP.MCustomClick(Sender: TObject);
begin
     FSerport.Show;
     FSerport.Eser.Text := SerPortName;
     Mttys0.Checked := FALSE;
     Mttys1.Checked := FALSE;
     MCustom.Checked := TRUE;
     SaveConfig;
end;

// "RS232 speed"

// "300 baud"
procedure TTRP.M300BClick(Sender: TObject);
begin
        M300B.Checked := TRUE;
        M2400B.Checked := FALSE;
        SerPortSpeed := 300;
        SaveConfig;
end;

// "2400 baud"
procedure TTRP.M2400BClick(Sender: TObject);
begin
        M300B.Checked := FALSE;
        M2400B.Checked := TRUE;
        SerPortSpeed := 2400;
        SaveConfig;
end;

// "Transceiver"
procedure TTRP.MTRANSClick(Sender: TObject);
begin
        MTRANS.Checked := not MTRANS.Checked;
        if MTRANS.Checked then begin
	        RTXState.Freq_tx := RTXState.Freq_rx;
        	if not SetTXfreq then Message(COMMANDFAILED);
	        DispTXf;
        end;
        SaveConfig;
end;

// "Status reading"
procedure TTRP.MStatusClick(Sender: TObject);
begin
  	MStatus.Checked := not MStatus.checked;
        SaveConfig;
        UpdatePanel;
end;

// "Enable all controls"
procedure TTRP.MENALLClick(Sender: TObject);
begin
        MENALL.Checked := not MENALL.Checked;
        if MENALL.Checked then EnableAllControls;
        UpdatePanel;
end;

//
// "Help" menu handling
//

// "About"
procedure TTRP.MABOUTClick(Sender: TObject);
begin
        FAbout.Show;
end;

// "Manual"
procedure TTRP.MMANClick(Sender: TObject);
begin
        FMAN.Show;
end;

// "GNU License"
procedure TTRP.MGNULICClick(Sender: TObject);
begin
        FGNU.Show;
end;

//
// Buttons handling (left block row 1: main tuning)
//

// Tune down
procedure TTRP.BTUNEDNClick(Sender: TObject);

begin
       	if RTXState.Freq_rx-RTXState.Freq_step >= MINRXF then begin
       		if SendCommand(Tune_Dn,'') then begin
       	       		RTXState.Freq_rx := RTXState.Freq_rx - RTXState.Freq_step;
       			DispRXf;
	       		if MTRANS.Checked then begin
              		        if RTXState.Freq_rx-RTXState.Freq_step >= MINTXF then begin
                        		sleep(50);
       	        			RTXState.Freq_tx := RTXState.Freq_rx;
               	        		if not SetTXFreq then Message(COMMANDFAILED);
                       			DispTXf;
                			sleep(50);
                       		end else begin
                               		Message(CANTTUNE);
                       		end;
                        end;
                 end else Message(COMMANDFAILED);
	end;
end;

// Step select
procedure TTRP.BRATEClick(Sender: TObject);
begin
        case RTXState.Freq_step of
        	10: begin
                    	if SendCommand(TuneStep100,'') then
                        	RTXState.Freq_step := 100
                        else
                                Message(COMMANDFAILED);
       		end;

                100: begin
                       	if SendCommand(TuneStep1k,'') then
                        	RTXState.Freq_step := 1000
                        else
                                Message(COMMANDFAILED);
                end;

                1000: begin
                        if SendCommand(TuneStep10,'') then
                        	RTXState.Freq_step := 10
                        else
                                Message(COMMANDFAILED);
       		end;

        end;
        UpdatePanel;
        DispRXf;
end;

// Tune up
procedure TTRP.BTUNEUPClick(Sender: TObject);

begin
        if RTXState.Freq_rx+RTXState.Freq_step <= MAXRXF then begin
		if SendCommand(Tune_Up,'') then begin
     	        	RTXState.Freq_rx := RTXState.Freq_rx + RTXState.Freq_step;
	             	DispRXf;
     		        if MTRANS.Checked then begin
              		        if RTXState.Freq_rx+RTXState.Freq_step <= MAXTXF then begin
	        			sleep(50);
        	             		RTXState.Freq_tx := RTXState.Freq_rx;
       			                if not SetTXFreq then Message(COMMANDFAILED);
                		        DispTXf;
                			sleep(50);
                		end else begin
                     			Message(CANTTUNE);
                		end;
                        end;
		end else
        		Message(COMMANDFAILED);
        end;
end;

//
// Buttons handling (block 1 row 2: BFO tuning)
//

procedure TTRP.BBFODNClick(Sender: TObject);

var s: string;

begin
       if SendCommand(BFO_Tune_Dn,'') then begin
             s := GetReply(3);
             DispBFOFreq(s);
       end else Message(COMMANDFAILED);
end;


procedure TTRP.BBFOUPClick(Sender: TObject);

var s: string;

begin
        if SendCommand(BFO_Tune_Up,'') then begin
                s := GetReply(3);
        	DispBFOfreq(s);
        end else Message(COMMANDFAILED);
end;

//
// Buttons handling (block 1 row 3: IF filter selection)
//

// Wide
procedure TTRP.BWIDEClick(Sender: TObject);
begin
	if SendCommand(Filt_Wide,'') then begin
	        RTXState.Filter:=FILTER_WIDE;
                UpdatePanel;
        end;
end;

// Intermediate
procedure TTRP.BINTERClick(Sender: TObject);
begin
	if SendCommand(Filt_Inter,'') then begin
        	RTXState.Filter:=FILTER_INTERMEDIATE;
                UpdatePanel;
         end else Message(COMMANDFAILED);
end;

// Narrow
procedure TTRP.BNARClick(Sender: TObject);
begin
        if SendCommand(Filt_Narrow,'') then begin
	        RTXState.Filter:=FILTER_NARROW;
                UpdatePanel;
        end else Message(COMMANDFAILED);
end;

// Very narrow
procedure TTRP.BVNARClick(Sender: TObject);
begin
	if SendCommand(Filt_Vnarrow,'') then begin
	        RTXState.Filter:=FILTER_VERYNARROW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

//
// Buttons handling (block 1 row 4: misc controls)
//

// Speaker
procedure TTRP.BSPKRClick(Sender: TObject);
begin
       	if SendCommand(Speaker_Toggle,'') then begin
                RTXState.Speaker_Enabled := not RTXState.Speaker_Enabled;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// RF preamp
procedure TTRP.BRFAMPClick(Sender: TObject);
begin
	if SendCommand(PreAmp_Toggle,'') then begin
                RTXState.RFAmp_Enabled := not RTXState.RFAmp_Enabled;
        	UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// RF attenuator
procedure TTRP.BRFATTClick(Sender: TObject);
begin
	if SendCommand(Atten_Toggle,'') then begin
                RTXState.RFAtt_Enabled := not RTXState.RFAtt_Enabled;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// Squelch
procedure TTRP.BSQLClick(Sender: TObject);
begin
	if SendCommand(Squelch_Toggle,'') then begin
                RTXState.Squelch_Enabled := not RTXState.Squelch_Enabled;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

//
// Buttons handling (block 1 row 5: AGC)
//

// AGC ON
procedure TTRP.AGCONClick(Sender: TObject);
begin
	if SendCommand(AGC_ON,'') then begin
                RTXstate.AGC := AVC_ON;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// AGC FAST
procedure TTRP.AGCFASTClick(Sender: TObject);
begin
       	if SendCommand(AGC_Fast,'') then begin
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
       end else
       		Message(COMMANDFAILED);
end;

//AGC SLOW
procedure TTRP.AGCSLOWClick(Sender: TObject);
begin
	if SendCommand(AGC_Slow,'') then begin
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// AGC OFF
procedure TTRP.AGCOFFClick(Sender: TObject);
begin
	if SendCommand(AGC_Off,'') then begin
                RTXstate.AGC := AVC_OFF;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

//
// Buttons handling (block 1 row 6: sensitivity)
//

// Sensitivity down
procedure TTRP.BSENSDNClick(Sender: TObject);
begin
        if not SendCommand(Sensitivity_Dn,'') then
                Message(COMMANDFAILED);
end;

// Sensitivity up
procedure TTRP.BSENSUPClick(Sender: TObject);
begin
        if not SendCommand(Sensitivity_Up,'') then
                Message(COMMANDFAILED);
end;

//
// Buttons handling (block 1 row 7: volume)
//

// Volume down
procedure TTRP.BVOLDNClick(Sender: TObject);

var s: string;

begin
        if RTXState.Volume < 99 then inc(RTXState.Volume);
        s := IntToStr(RTXState.Volume);
        if length(s) < 2 then s := '0'+s;
        if not SendCommand(AF_GainSet, s+CR) then
                Message(COMMANDFAILED);
end;

// Volume up
procedure TTRP.BVOLUPClick(Sender: TObject);

var s: string;

begin
        if RTXState.Volume > 0 then dec(RTXState.Volume);
        s := IntToStr(RTXState.Volume);
        if length(s) < 2 then s := '0'+s;
        if not SendCommand(AF_GainSet, s+CR) then
                Message(COMMANDFAILED);
end;

//
// Buttons handling (block 2: Mode)
//

// USB
procedure TTRP.BUSBClick(Sender: TObject);
begin
        if SendCommand(Mode_USB,'') then begin
                RTXState.Mode := M_USB;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// LSB
procedure TTRP.BLSBClick(Sender: TObject);
begin
        if SendCommand(Mode_LSB,'') then begin
                RTXState.Mode := M_LSB;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// AM
procedure TTRP.BAMClick(Sender: TObject);
begin
 	if SendCommand(Mode_AM, '') then begin
                RTXState.Mode := M_AM;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
 	end else
        	Message(COMMANDFAILED);
end;

// Jump to 500 kHz
procedure TTRP.B500Click(Sender: TObject);
begin
      if SendCommand(F500k,'') then begin
                RTXState.Mode := M_500k;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
      end else
      		Message(COMMANDFAILED);
end;

// TELEX
procedure TTRP.BTELEXClick(Sender: TObject);
begin
        if SendCommand(Mode_TELEX,'') then begin
        	RTXstate.Mode := M_TLX;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// R3E
procedure TTRP.BR3EClick(Sender: TObject);
begin
        if SendCommand(Mode_R3E,'') then begin
                RTXState.Mode := M_R3E;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// Jump to 2182 kHz
procedure TTRP.B2182Click(Sender: TObject);
begin
	if SendCommand(F2182k,'') then begin
                RTXState.Mode := M_2182K;
                RTXState.Filter:=FILTER_DEFAULT;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// CW
procedure TTRP.BCWClick(Sender: TObject);
begin
        if SendCommand(Mode_CW,'') then begin
                RTXState.Mode := M_CW;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// MCW
procedure TTRP.BMCWClick(Sender: TObject);
begin
        if SendCommand(Mode_MCW,'') then begin
                RTXState.Mode := M_MCW;
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

procedure TTRP.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
	if MStatus.Checked then begin
                TStatus.Enabled := FALSE;
        	Enable_Status := FALSE;
        end;
	sleep(100);
        CloseRemote;
        SerFlush(SerPort);
        SerClose(SerPort);
        SaveConfig;
        SaveLastState;
        Halt;
end;

//
// Buttons handling (block 3: numeric keypad & frequency entry)
//

// RX
procedure TTRP.BRXClick(Sender: TObject);
begin
        OldRXFreq := RXfreq.Caption;
        RXfreq.Caption := '';
        RXFBuf := '';
        SetRXf := TRUE;
end;

// Recall channel
procedure TTRP.BRCLClick(Sender: TObject);
begin
        OldRXFreq := RXFreq.Caption;
        RXFreq.Caption := '';
        RclChan := TRUE;
end;

// TX
procedure TTRP.BTXClick(Sender: TObject);
begin
     	OldTXFreq := TXfreq.Caption;
        TXfreq.Caption := '';
        TXFBuf := '';
        SetTXf := TRUE;
end;

// 0
procedure TTRP.B0Click(Sender: TObject);
begin
        Numkey('0');
end;

// 1
procedure TTRP.B1Click(Sender: TObject);
begin
       Numkey('1');
end;

// 2
procedure TTRP.B2Click(Sender: TObject);
begin
       Numkey('2');
end;

// 3
procedure TTRP.B3Click(Sender: TObject);
begin
       Numkey('3');
end;

// 4
procedure TTRP.B4Click(Sender: TObject);
begin
        Numkey('4');
end;

// 5
procedure TTRP.B5Click(Sender: TObject);
begin
        Numkey('5');
end;

// 6
procedure TTRP.B6Click(Sender: TObject);
begin
        Numkey('6');
end;

// 7
procedure TTRP.B7Click(Sender: TObject);
begin
        Numkey('7');
end;

// 8
procedure TTRP.B8Click(Sender: TObject);
begin
        Numkey('8');
end;

// 9
procedure TTRP.B9Click(Sender: TObject);
begin
        Numkey('9');
end;

// Enter
procedure TTRP.ENTERClick(Sender: TObject);

var f: longint;
    chn, hhmm: integer;
    done: boolean = FALSE;

begin
        if SetRXf then begin
                if RXFREQ.Caption = '' then RXFREQ.Caption := OldRXFreq;
                RTXstate.Freq_rx := trunc(StrToFloat(RXFREQ.Caption) * 1000);
                if (RTXstate.Freq_rx>=10000) and (RTXState.Freq_rx < 30000000) then begin
			if not SetRXFreq then Message(COMMANDFAILED);
                	sleep(250);
                end;
                SetRXf := FALSE;
                RXFBuf := '';
                DIspRXf;
		done := TRUE;
        end;

        if SetTXf then begin
                if TXFREQ.Caption = '' then TXFREQ.Caption := OldRXFreq;
                f := trunc(StrToFloat(TXFREQ.Caption) * 1000);
                if (f >= 1605000) and (f <= 29999900) then begin
                        RTXState.Freq_tx := f;
                        if not SetTXfreq then Message(COMMANDFAILED);
                        sleep(250);
                end else Message(CANTTUNE);
               	SetTXf := FALSE;
                TXFBuf := '';
               	DispTXf;
		done := TRUE;
        end;

        if StoChan then begin
                chn := StrToInt(RXFREQ.Caption);
                if (chn >= 0) and (chn < 76) then begin
                        if SendCommand(StoreChannel, RXFREQ.Caption+CR) then begin
                		DispRXF;
		        end else
                        	Message(COMMANDFAILED);
                end;
       		RXFBuf := '';
       		StoChan := FALSE;
       		done := TRUE;
        end;

        if RclChan then begin
                chn := StrToInt(RXFREQ.Caption);
                if (chn >= 0) and (chn < 76) then begin
                	if SendCommand(RecallChannel, RXFREQ.Caption+CR) then begin
	                	RXFreq.Caption := 'SEE C.U.';
        	        	TXFreq.Caption := 'SEE C.U.';
                	end else
                        	Message(COMMANDFAILED);
                end;
		RXFBuf := '';
		RclChan := FALSE;
       		done := TRUE;
        end;

        if SetClock then begin
                if RXFreq.Caption <> '' then begin
	                hhmm := StrToInt(RXFREQ.Caption);
        	        if (hhmm div 100 < 24) and (hhmm mod 100 < 60) then begin
                	        if not SendCommand(Set_Time, RXFREQ.Caption+CR) then
                                        Message(COMMANDFAILED);
	                end;
                end;
        	RXFBuf := '';
                DispRXf;
                SetClock := FALSE;
		done := TRUE;
        end;

        if not Done then begin
                if not SendCommand(CR, '') then begin
			Message(COMMANDFAILED);
                end;
        end;
end;

//
// Buttons handling (block 4: tune & power level)
//

// Tune
procedure TTRP.TUNEClick(Sender: TObject);
var s: string;
begin
        Enable_Status := FALSE;
        if SendCommand(TX_TUNE,'') then begin
                s := GetReply(1);
                if s = '>' then begin
                        Message('Tuning completed');
                end else
                	Message(COMMANDFAILED);
        end;
        Enable_Status := TRUE;
end;

// Low power
procedure TTRP.BLOWClick(Sender: TObject);
begin
        if SendCommand(TX_LowPwr, '') then begin
                RTXState.TX_power := LOW_POWER;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// Medium power
procedure TTRP.BMEDClick(Sender: TObject);
begin
        if SendCommand(TX_MediumPwr,'') then begin
                RTXState.TX_power := MEDIUM_POWER;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

// Full power
procedure TTRP.BFULLClick(Sender: TObject);
begin
        if SendCommand(TX_HighPwr,'') then begin
                RTXState.TX_power := FULL_POWER;
                UpdatePanel;
        end else
        	Message(COMMANDFAILED);
end;

//
// Buttons handling (block 5 row 1: misc functions 2)
//

// Store channel
procedure TTRP.BSTOClick(Sender: TObject);
begin
        RXFreq.Caption := '';
        StoChan := TRUE;
end;

// Scan
procedure TTRP.BSCANClick(Sender: TObject);
begin
        if SendCommand(Scan, '') then begin
                 // we must do something?
        end else
        	Message(COMMANDFAILED);
end;

// Set clock
procedure TTRP.BSETTClick(Sender: TObject);
begin
        SetClock := TRUE;
        RxFreq.Caption := '';
        RXFBuf := '';
end;

// Duplex
procedure TTRP.BDUPClick(Sender: TObject);
begin
         if SendCommand(Duplex, '') then begin
                 // we must do something?
         end else
         	Message(COMMANDFAILED);
end;


//
// Buttons handling (block 5 row 2: Dimmer)
//

// Dimmer down
procedure TTRP.BDIMDNClick(Sender: TObject);
begin
	if SendCommand(Dimmer_Dn,'') then begin
                // we must do something?
        end else
        	Message(COMMANDFAILED);
end;

// Dimmer up
procedure TTRP.BDIMUPClick(Sender: TObject);
begin
        if SendCommand(Dimmer_Up,'') then begin
                // we must do something?
        end else
        	Message(COMMANDFAILED);
end;


//
// Buttons handling (block 5 row 3: TX & power on/off )
//

// TX enabled/disabled
procedure TTRP.BTXONOFFClick(Sender: TObject);
begin
       	if SendCommand(TX_OnOff,'') then begin
                RTXState.TX_Enabled := not RTXState.TX_Enabled;
                UpdatePanel;
                if RTXState.TX_Enabled then begin
                	DispTXf;
                end;
       end else
       		Message(COMMANDFAILED);
end;

// Power on/off (NB: Starts & exits program, does not switch on&off radio!)
procedure TTRP.BONOFFClick(Sender: TObject);

begin
        if SerPort > 0 then begin
                Enable_Status := FALSE;
                if MStatus.Checked then begin
                        TSTatus.Enabled := FALSE;
                        Enable_Status := FALSE;
                end;
                CloseRemote;
                SerFlush(SerPort);
          	SerClose(SerPort);
                SerPort := 0;
                SaveConfig;
                SaveLastState;
                BONOFF.Color := clDefault;
                DisableAllControls;
        end else begin
             	ReadConfig;
		SerPort := SerOpen(SerPortName);
        	if SerPort > 0 then begin
                       	if M300B.Checked then begin
                		SerSetParams(SerPort,300,7,OddParity,1,[]);
                       end;
                	if M2400B.Checked then begin
                		SerSetParams(SerPort,2400,7,OddParity,1,[]);
                	end;
     			SerSetDTR(SerPort,True);
     			SerSetRTS(SerPort,True);

                       if OpenRemote then begin
                               	BONOFF.COlor := clLime;
                                DispRXf;
                                DispTXf;
                                LoadLastState;
                                RestoreState;
				EnableAllControls;
                                UpdatePanel; // must be called last
                        end else begin
                                SerFlush(SerPort);
                                SerClose(SerPort);
                                SerPort := 0;
                          	if Application.MessageBox('Failed to initialize communications.'
                                   +LineEnding
                                   +'Retry?',
                                    'Error',
                                    MB_ICONQUESTION+MB_YESNO) = ID_NO then begin
                                	halt;
                                end else begin
                                	BONOFFClick(Sender);
                                end;
                        end;
		end else begin
                        ShowMessage('Can''t open serial port '+SerPortName);
                        halt;
                end;
        end;
end;

//
// Extra program functions (not present in CU8000)
//

// Alternative tuning step selection way (click on indicators)

// 1 kHz step
procedure TTRP.STEP1KMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if SendCommand(TuneStep1k, '') then begin
  	RTXState.Freq_step := 1000;
  	UpdatePanel;
        DispRXf;
  end else
  	Message(COMMANDFAILED);
end;

// 100 Hz step
procedure TTRP.STEP100HMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
  if SendCommand(TuneStep100, '') then begin
	RTXState.Freq_step := 100;
  	UpdatePanel;
        DispRXf;
  end else
  	Message(COMMANDFAILED);
end;

// 10 Hz step
procedure TTRP.STEP10HMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
  if SendCommand(TuneStep10, '') then begin
        RTXState.Freq_step := 10;
        UpdatePanel;
        DispRXf;
  end else
  	Message(COMMANDFAILED);
end;

// Alternative frequency setting way: left/right click on the frequency figures
// Clicking on the decimal point rewrites displayed frequency
procedure TTRP.RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);

var step: integer;

begin
        case X of
                0..31:    step := 10000000;
                32..63:   step := 1000000;
                64..95:   step := 100000;
                96..127:  step := 10000;
                128..159: step := 1000;
                160..191: step := 0; 		// click on decimal point
                192..223: step := 100;
                otherwise exit;
        end;
        if Button = mbLeft then begin
                if RTXState.Freq_rx - step >= MINRXF then
	     		RTXState.Freq_rx := RTXState.Freq_rx-step;
	end;
        if Button = mbRight then begin
                if RTXState.Freq_rx + step <= MAXRXF then
		        RTXState.Freq_rx := RTXState.Freq_rx+step;
	end;
        if not SetRXfreq then
                Message(COMMANDFAILED);
        sleep(150);
        DispRXf;

        if RTXState.TX_Enabled and MTrans.checked then begin
        	RTXState.Freq_tx := RTXState.Freq_rx;
                sleep(150);
                if not SetTXfreq then Message(COMMANDFAILED);
                sleep(150);
                DispTXf;
        end;
end;

// Same for TX
procedure TTRP.TXfreqMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);

var step: integer;

begin
        if RTXState.TX_Enabled then begin
	        case X of
	        	0..31:    step := 10000000;
        	        32..63:   step := 1000000;
                	64..95:   step := 100000;
	                96..127:  step := 10000;
        	        128..159: step := 1000;
                	160..191: step := 0;	// click on decimal point
	                192..223: step := 100;
        	        otherwise exit;
	        end;
        	if Button = mbLeft then begin
			if RTXState.Freq_tx - step >= MINTXF then
        			RTXState.Freq_tx := RTXState.Freq_tx-step;
	        end;
        	if Button = mbRight then begin
	        	if RTXState.Freq_tx + step <= MAXTXF then
        		        RTXState.Freq_tx := RTXState.Freq_tx+step;
	       	end;
        	if not SetTXfreq then Message(COMMANDFAILED);
	        sleep(150);
	        DispTXf;

        	if MTrans.Checked then begin
        		RTXState.Freq_rx := RTXState.Freq_tx;
	                sleep(150);
        	        if not SetRXfreq then Message(COMMANDFAILED);
                	sleep(150);
	                DispRXf;
        	end;
        end;
end;


// Switch receive/transmit. In transmit sends " command every 2s
// (" has 3s internal timeout)
// This command works in all modes except CW, but TX audio comes always from
// REMOTE inputs (TELEX and/or AUX?) and CU microphone input (LOCAL) is ignored.
procedure TTRP.BTRANSClick(Sender: TObject);
begin
        RTXState.PTT_state := not RTXState.PTT_State;
        if RTXState.PTT_State then begin
	        if SendCommand(TX_Cmd,'') then begin
        		BTRANS.Color := clRed;
                end else Message(COMMANDFAILED);
        end else begin
                if SendCommand(RX_Cmd,'') then begin
        		BTRANS.Color := clLime;
                end else Message(COMMANDFAILED);
        end;
end;

// Copy RX frequency to TX frequency

procedure TTRP.BTXEQRXClick(Sender: TObject);
begin
        if SendCommand(EQTXRX, '') then begin
	        RTXState.Freq_tx := RTXState.Freq_rx;
        	DispRXf;
	        DispTXf;
        end else Message(COMMANDFAILED);
end;

//
// Timers
//

// Clear MSG label
procedure TTRP.MESGTimer(Sender: TObject);
begin
	MSG.Caption := '';
        MESG.Enabled := FALSE;
end;

// Timer to update S-meter and check for status messages every 500 ms
procedure TTRP.SMTimer(Sender: TObject);

var i: integer;

begin
        SMETER.Position := s;
        WMETER.Position := t;

	for i := 1 to length(status) do begin
                case Status[i] of
	               	'u': begin
                               	Message('ATU8000 tuning successful');
        	     	end;
	               	'v': begin
	               		Message('ATU8000 tuning erroneous');
                       	end;
                        'w': begin
                            	Message('SWR < 4');
                       	                PLOW.Brush.Color := clLime;
                       	end;
                        'x': begin
               	             	Message('SWR > 4');
                               	        PLOW.Brush.Color := clGreen;
       	                end;
		        'y': begin
      			               	SRPWR.Brush.Color := clGreen;
      			end;
        	        'z': begin
                	        SRPWR.Brush.Color := clLime;
        	       	end;
                	'>': begin
                             	PLOW.Brush.Color := clLime;
		              	Message('Status: got >');
        		end;
           	end;
       	end;
end;

// TX timer. If PTT active sends " command every 2s
procedure TTRP.TXTimer(Sender: TObject);
begin
        if RTXState.PTT_State then
                if not SendCommand(TX_cmd,'') then Message(COMMANDFAILED);
end;

// Clock timer. If TX off, shows time in the TX frequency display
procedure TTRP.ClockTimer(Sender: TObject);
begin
        if not RTXState.TX_Enabled then begin
        	if flash then
        		TXfreq.Caption := FormatDateTime('hh:nn',now)
		else
        		TXfreq.Caption := FormatDateTime('hh nn',now);
                flash := not flash;
	end;
end;


// Status timer. Get status (S & RF meters, etc.) every 500 ms.
procedure TTRP.TStatusTimer(Sender: TObject);

VAR buf: char = chr(0);
    sc, tc: char;
    nc: integer;

begin
        if Enable_Status then begin
                status := '';
		SerWrite(SerPort, Get_Status[1], 1);
		repeat
			nc := SerRead(SerPort, buf, 1);
		until (nc > 0);

        	sleep(110);

                repeat
                	repeat
                		nc := SerRead(SerPort, buf, 1);
                	until (nc > 0);
                        SerWrite(SerPort, ACK[1], 1);
                        if (buf in StatusRange) then status := status+buf;
                until (buf in MetersRange);

                sc := buf;

//		Message('Got S='+sc);

                repeat
                	nc := SerRead(SerPort, buf, 1);
        	until (nc > 0);

                tc := buf;

                // Disable status reading
                SerWrite(SerPort, CAN[1], 1);
		repeat
			nc := SerRead(SerPort, buf, 1);
		until (nc > 0);

//             	Message('status: '+status+' S:'+sc+' T:'+tc);

	       	s := ord(sc) - ord('`');
	       	t := ord(tc) - ord('`');
        end;
end;

// Things to do at startup
initialization

begin
        HomeDir := GetUserDir+'/.SkantiControl/';
   	StateDir := HomeDir+'/States/';

   	if not DirectoryExists(HomeDir) then CreateDir(HomeDir);
   	if not DirectoryExists(StateDir) then CreateDir(StateDir);
end;

end.

